
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <stdlib.h>

void truecolor(Display *dpy, XVisualInfo *vi)
{
	int i, j, m, n;
	XColor *color;
	int scr = DefaultScreen(dpy);
	Colormap cmap = DefaultColormap(dpy, scr);
	unsigned long r, g, b;
	unsigned short x;

printf("It's TrueColor!\n");
	n = vi->colormap_size;
	m = vi->bits_per_rgb;
	color = malloc(n*sizeof *color);
	for (i = 0; i < n; i++) {
		color[i].pixel = (i<<(2*m)) | (i<<m) | (n-i);
	}
	XQueryColors(dpy, cmap, color, n);
	/* There are so few elements, so we sort of bubble sort */
	for (i = 0; i < n; i++) {
		for (j = i+1; j < n; j++) {
			if (color[i].red > color[j].red) {
printf("Swapping red\n");
				x = color[i].red;
				color[i].red = color[j].red;
				color[j].red = x;
				r = j<<(2*m);
			} else {
				r = i<<(2*m);
			}
			if (color[i].green > color[j].green) {
printf("Swapping green\n");
				x = color[i].green;
				color[i].green = color[j].green;
				color[j].green = x;
				g = j<<m;
			} else {
				g = i<<m;
			}
			if (color[i].blue > color[j].blue) {
printf("Swapping blue\n");
				x = color[i].blue;
				color[i].blue = color[j].blue;
				color[j].blue = x;
				b = j;
			} else {
				b = i;
			}
			color[i].pixel = r | g | b;
		}
printf("%d\t%06lx\n", i, color[i].pixel);
	}
}

int main(void)
{
	XVisualInfo *vi;
	Display *dpy;
	long vim = VisualIDMask;
	XVisualInfo vit;
	int n;
	int scr;

	dpy = XOpenDisplay(NULL);
	scr = DefaultScreen(dpy);
	vit.visualid = XVisualIDFromVisual(DefaultVisual(dpy, scr));
	vi = XGetVisualInfo(dpy, vim, &vit, &n);
	printf("screen = %d\n", vi->screen);
	printf("rgbmask = (%lx,%lx,%lx)\n", vi->red_mask, vi->green_mask, vi->blue_mask);
	printf("class = %d\n", vi->class);
	if (vi->class == TrueColor) truecolor(dpy, vi);
	printf("colormap_size = %d\n", vi->colormap_size);
	printf("bits_per_rgb = %d\n", vi->bits_per_rgb);
	return 0;
}
